// complex_numbers.cpp
//
// Pretezovani operatoru pro tridu cplx - komplexni cisla
// Chcete=li tento soubor prekladat na nekterem ze starsich prekladacu, odstrante  
// komentar u nasledujiciho prikazu:
// typedef int bool;

// UNARNI OPERATORY
// Operator minus (unarni): vrati kopii instance s obracenymi znamenky slozek
// Je zde dvakrat, jednou jako metoda (uzavrena do komentare), podruhe jako
// spratelena funkce - obe funguji, v programu smi byt ale jen jedna
// Operator + (unarni): vrati aktualni instanci beze zmeny
// Operator !: vrati true, je-li re == 0 a zaroven im == 0, jinak vrati false

// BINARNI OPERATORY
// Operator + (scitani)
// Operator * nasobeni
#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <math.h>
#include <iostream>
using namespace std;

class cplx {
private:
	double re, im;
public:
	cplx(double r = 0, double i = 0) : re(r), im(i) {}
	double Re() { return re; }
	double Im() { return im; }
	friend double Abs(cplx& c) { return sqrt(c.re * c.re + c.im * c.im); }

	// UNARNI OPERATORY
	// Operator unarni minus (otoci znamenka obou slozek)
	// jako metoda bez parametru
	//cplx operator-() { return cplx(-re, -im); }  //  = THE BEST WAY  !!!!!!!!!

	// Jina moznost: spratelena funkce s jednim parametrem
	friend cplx operator-(cplx& c);

	bool operator!() { return !re && !im; }   //  = THE BEST WAY  !!!!!!!!!
	cplx operator+() { return *this; }        //  = THE BEST WAY  !!!!!!!!!

// BINARNI OPERATORY
// Scitani jako metoda: funguje, ale ma sve problemy, pouzijeme radeji
// spratelenou funkci
// cplx operator+(cplx b) { return cplx(re+b.re, im+b.im);}
// nezvladne c = 5 + a; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	friend cplx operator+(cplx a, cplx b);    //  = THE BEST WAY  !!!!!!!!!
	friend cplx operator*(cplx a, cplx b);    //  = THE BEST WAY  !!!!!!!!!
};

// Jina moznost, jak deklarovat unarni minus pro komplexni cisla
cplx operator-(cplx& c)
{
	return cplx(-c.re, -c.im);
}

// Jina moznost, jak deklarovat scitani pro komplexni cisla
cplx operator*(cplx a, cplx b)
{
	return cplx(a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re);
}

/*
cplx cplx::operator+(cplx b)
{
	return cplx(re+b.re, im+b.im);
}  */
/*
cplx cplx::operator+(cplx a, cplx b)
{
	return cplx(a.re+b.re, a.im+b.im);
}  */

cplx operator+(cplx a, cplx b)
{
	return cplx(a.re + b.re, a.im + b.im);
}

/*
// Znovu operator scitani, pochybna implementace
//NEFUNGUJE VE SLOZITEJSICH VYRAZECH - NENI REENTRANTNI
cplx& operator+(cplx &a, cplx &b)
{
	static cplx pom;
	pom = cplx(a.re+b.re, a.im+b.im);
	return pom;
}
*/

int my_getch();

int main()
{
	cplx a(1, 1), b, i(0, 1), j(1, 0);
	b = -a;		// Vola se cplx::operator -()
	bool c = !a;
	c = !cplx(0, 1);
	b = a + i;
	b = a + 5;
	b = 5 + a;
	b = (a + j) * (i + j);

	cout << "\n  There is no output in this example.\n";
	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
int my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
	return 0;
}
//---------------------------------------------------------------------------
